require_relative 'player'
require_relative 'game_turn'
require_relative 'treasure_trove'
module ToccoStudioGame
class Game
	attr_reader :title
def initialize(title)
	@title = title
	@players = []

end
def load(file_name)
  File.open(file_name) do |file|
  file.each_line do |line|
    player,health = line.split(/[\s,]/)
    playerAdd = Player.new(player, Integer(health))
    add_player(playerAdd)
  end
end

def save(file_name = "high_scores.txt")
  File.open(file_name, 'w') do |file|
  file.puts "#{@title} High Scores:"
  @players.sort.each do |player|
  file.puts high_score_entry(player)
  end
  end

  end

  end
def add_player(aPlayer)
	@players << aPlayer
end
def high_score_entry(player)
  "#{player.name} ....... #{player.score}"
  end
def play(rounds)
	winCheck = false
		puts "There are #{@players.size} players in #{title}:"
		@players.each do |player|
			puts player
	end
    treasures = TreasureTrove::TREASURES
    puts "There are #{treasures.length} treasures to be found."
    treasures.each do |item|
    	puts "A #{item.name} is worth #{item.points} points"
    end
	rounds.times do |count|
		puts "Round #{count+1} \n----------------------------------------"
	 @players.each do |player| 
	 GameTurn.take_turn(player)
    puts player
    if player.score >= 500000
    	winCheck = true
    end
  end
  break if winCheck == true
end
print_stats
	end
	def print_stats
		puts "#{@title} Statistics:"
		strongPlayers = []
		wimpyPlayers =[]
	@players.each do |player| 
	 if player.strong? == true
	 	strongPlayers << "#{player.name}(#{player.health})"
	else
		wimpyPlayers << "#{player.name}(#{player.health})"
	end
  end
  puts "#{strongPlayers.length} Strong Players:"
  puts strongPlayers
  puts "#{wimpyPlayers.length} Wimpy Players"
  puts wimpyPlayers
  puts "#{title} High Scores:"
  highScores = @players.sort
  highScores.each do |player|
  puts high_score_entry(player)
  end
   puts "\n"
  @players.each do|player|
  	puts "#{player.name}'s Point Totals:"
  	player.each_found_treasure do |treasure|
    puts "#{treasure.points} total #{treasure.name} points"
    end
  	puts "#{player.score} grand total points \n"

  end
	end

end
end

